Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.axis
Class AxisFault

    java.lang.Object
      java.lang.Throwable
          java.lang.Exception
              java.io.IOException
                  java.rmi.RemoteException
                      org.apache.axis.AxisFault

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  NoEndPointException

public class AxisFault
extends RemoteException

An exception which maps cleanly to a SOAP fault. This is a base class for exceptions which are mapped to faults. SOAP faults contain

1. A fault string
2. A fault code
3. A fault actor
4. Fault details; an xml tree of fault specific stuff

Author:
  Doug Davis (dug@us.ibm.com), James Snell (jasnell@us.ibm.com), Steve Loughran
See Also:
  Serialized Form

Field Summary
`protected String` | `faultActor`
`protected javax.xml.namespace.QName` | `faultCode`
`protected Vector` | `faultDetails`
`protected ArrayList` | `faultHeaders` SOAP headers which should be serialized with the Fault List
`protected String` | `faultNode`
`protected String` | `faultString`
`protected Vector` | `faultSubCode` SOAP1.2 addition: subcodes of faults; a Vector of QNames

Fields inherited from class java.rmi.RemoteException
`detail`

Constructor Summary
`` | `AxisFault()` No-arg constructor for building one from an XML stream.
`protected` | `AxisFault(Exception target)` Wrap an AxisFault around an existing Exception - this is private to force everyone to use makeFault() above, which sanity-checks us.
`` | `AxisFault(javax.xml.namespace.QName code, javax.xml.namespace.QName[] subcodes, String faultString, String actor, String node, Element[] details)` make a fault in any namespace
`` | `AxisFault(javax.xml.namespace.QName code, String faultString, String actor, Element[] details)` make a fault in any namespace
`` | `AxisFault(String message)` create a simple axis fault from the message.
`` | `AxisFault(String code, String faultString, String actor, Element[] details)` make a fault
`` | `AxisFault(String message, Throwable target)` create a fault from any throwable; When faulting a throwable (as opposed to an exception), stack trace information does not go into the fault.

Method Summary
`void` | `addFaultDetail(Element detail)` append an element to the fault detail list
`void` | `addFaultDetail(javax.xml.namespace.QName qname, String body)` create an element of the given qname and add it to the details
`void` | `addFaultDetailString(String detail)` add a string tag to the fault details.
`void` | `addFaultSubCode(javax.xml.namespace.QName code)` This is new in SOAP 1.2, ignored in SOAP 1.1
`void` | `addFaultSubCodeAsString(String code)` This is new in SOAP 1.2, ignored in SOAP 1.1
`void` | `addHeader(SOAPHeaderElementAxisImpl header)` Add a SOAP header which should be serialized along with the fault.
`void` | `clearFaultDetails()` clear the fault details list
`void` | `clearFaultSubCodes()` This is new in SOAP 1.2, ignored in SOAP 1.1
`void` | `clearHeaders()` clear all fault headers
`void` | `dump()` dump the fault info to the log at debug level
`String` | `dumpToString()` turn the fault and details into a string, with XML escaping.
`String` | `getFaultActor()` get the fault actor
`javax.xml.namespace.QName` | `getFaultCode()` get the fault code
`Element[]` | `getFaultDetails()` get all the fault details
`String` | `getFaultNode()` This is new in SOAP 1.2
`String` | `getFaultReason()` This is SOAP 1.2 equivalent of `getFaultString()`
`String` | `getFaultRole()` This is SOAP 1.2 equivalent of `getFaultActor()`
`String` | `getFaultString()` get the fault string; this will never be null but may be the empty string
`javax.xml.namespace.QName[]` | `getFaultSubCodes()` get the fault subcode list; only used in SOAP 1.2
`ArrayList` | `getHeaders()` Get the SOAP headers associated with this fault.
`protected void` | `initFaultSubCodes()` do whatever is needed to create the fault subcodes data structure, if it is needed
`Element` | `lookupFaultDetail(javax.xml.namespace.QName qname)` Find a fault detail element by its qname
`static AxisFault` | `makeFault(Exception e)` Make an AxisFault based on a passed Exception.
`void` | `output(SerializationContext context)` add this fault and any needed headers to the output context
`void` | `printStackTrace(PrintStream ps)` The override of the base class method prints out the fault info before the stack trace
`void` | `printStackTrace(PrintWriter pw)` The override of the base class method prints out the fault info before the stack trace
`boolean` | `removeFaultDetail(javax.xml.namespace.QName qname)` find and remove a specified fault detail element
`void` | `setFaultActor(String actor)` set the fault actor
`void` | `setFaultCode(javax.xml.namespace.QName code)` set the fault code
`void` | `setFaultCode(String code)` Deprecated. expect to see this go away after 1.1, use setFaultCodeAsString instead!
`void` | `setFaultCodeAsString(String code)` set a fault code string that is turned into a qname in the SOAP 1.1 or 1.2 namespace, depending on the current context
`void` | `setFaultDetail(Element[] details)` set the fault detail element to the arrary of details
`void` | `setFaultDetailString(String details)` set the fault details to a string element.
`void` | `setFaultNode(String node)` This is new in SOAP 1.2
`void` | `setFaultReason(String str)` This is SOAP 1.2 equivalent of `setFaultString(java.lang.String)`
`void` | `setFaultRole(String role)` This is SOAP 1.2 equivalent of `setFaultActor(java.lang.String)`
`void` | `setFaultString(String str)` set a fault string;
`String` | `toString()` string operator
`void` | `writeDetails(javax.xml.namespace.QName qname, SerializationContext context)` Writes any exception data to the faultDetails This can be overrided (and is) by emitted exception clases.

Methods inherited from class java.rmi.RemoteException
`getCause, getMessage`

Methods inherited from class java.lang.Throwable
`fillInStackTrace, getLocalizedMessage, getStackTrace, initCause, printStackTrace, setStackTrace`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### faultCode

    protected javax.xml.namespace.QName faultCode

### faultSubCode

    protected Vector faultSubCode

  SOAP1.2 addition: subcodes of faults; a Vector of QNames

### faultString

    protected String faultString

### faultActor

    protected String faultActor

### faultDetails

    protected Vector faultDetails

### faultNode

    protected String faultNode

### faultHeaders

    protected ArrayList faultHeaders

  SOAP headers which should be serialized with the Fault List

Constructor Detail

### AxisFault

    public AxisFault(String code,
                     String faultString,
                     String actor,
                     Element[] details)

  make a fault

Parameters:
  `code` - fault code which will be passed into the Axis namespace
  `faultString` - fault string
  `actor` - fault actor
  `details` - details; if null the current stack trace and classname is inserted into the details.

### AxisFault

    public AxisFault(javax.xml.namespace.QName code,
                     String faultString,
                     String actor,
                     Element[] details)

  make a fault in any namespace

Parameters:
  `code` - fault code which will be passed into the Axis namespace
  `faultString` - fault string
  `actor` - fault actor
  `details` - details; if null the current stack trace and classname is inserted into the details.

### AxisFault

    public AxisFault(javax.xml.namespace.QName code,
                     javax.xml.namespace.QName[] subcodes,
                     String faultString,
                     String actor,
                     String node,
                     Element[] details)

  make a fault in any namespace

Parameters:
  `code` - fault code which will be passed into the Axis namespace
  `subcodes` - fault subcodes which will be pased into the Axis namespace
  `faultString` - fault string
  `actor` - fault actor, same as fault role in SOAP 1.2
  `node` - which node caused the fault on the SOAP path
  `details` - details; if null the current stack trace and classname is inserted into the details.
Since:
  axis1.1

### AxisFault

    protected AxisFault(Exception target)

  Wrap an AxisFault around an existing Exception - this is private to force everyone to use makeFault() above, which sanity-checks us.

### AxisFault

    public AxisFault(String message)

  create a simple axis fault from the message. Classname and stack trace go into the fault details.

Parameters:
  `message` -

### AxisFault

    public AxisFault()

  No-arg constructor for building one from an XML stream.

### AxisFault

    public AxisFault(String message,
                     Throwable target)

  create a fault from any throwable; When faulting a throwable (as opposed to an exception), stack trace information does not go into the fault.

Parameters:
  `message` - any extra text to with the fault
  `target` - whatever is to be turned into a fault

Method Detail

### makeFault

    public static AxisFault makeFault(Exception e)

  Make an AxisFault based on a passed Exception. If the Exception is already an AxisFault, simply use that. Otherwise, wrap it in an AxisFault. If the Exception is an InvocationTargetException (which already wraps another Exception), get the wrapped Exception out from there and use that instead of the passed one.

### clearFaultDetails

    public void clearFaultDetails()

  clear the fault details list

### dump

    public void dump()

  dump the fault info to the log at debug level

### dumpToString

    public String dumpToString()

  turn the fault and details into a string, with XML escaping. subclassers: for security (cross-site-scripting) reasons, escape everything that could contain caller-supplied data.

  Returns:
    stringified fault details

### setFaultCode

    public void setFaultCode(javax.xml.namespace.QName code)

  set the fault code

  Parameters:
    `code` - a new fault code

### setFaultCode

    public void setFaultCode(String code)

  Deprecated. expect to see this go away after 1.1, use setFaultCodeAsString instead!

  Set the fault code (as a String).

### setFaultCodeAsString

    public void setFaultCodeAsString(String code)

  set a fault code string that is turned into a qname in the SOAP 1.1 or 1.2 namespace, depending on the current context

  Parameters:
    `code` - fault code

### getFaultCode

    public javax.xml.namespace.QName getFaultCode()

  get the fault code

  Returns:
    fault code QName or null if there is none yet.

### addFaultSubCodeAsString

    public void addFaultSubCodeAsString(String code)

  This is new in SOAP 1.2, ignored in SOAP 1.1

  Since:
    axis1.1

### initFaultSubCodes

    protected void initFaultSubCodes()

  do whatever is needed to create the fault subcodes data structure, if it is needed

### addFaultSubCode

    public void addFaultSubCode(javax.xml.namespace.QName code)

  This is new in SOAP 1.2, ignored in SOAP 1.1

  Since:
    axis1.1

### clearFaultSubCodes

    public void clearFaultSubCodes()

  This is new in SOAP 1.2, ignored in SOAP 1.1

  Since:
    axis1.1

### getFaultSubCodes

    public javax.xml.namespace.QName[] getFaultSubCodes()

  get the fault subcode list; only used in SOAP 1.2

  Returns:
    null for no subcodes, or a QName array
  Since:
    axis1.1

### setFaultString

    public void setFaultString(String str)

  set a fault string;

  Parameters:
    `str` - new fault string; null is turned into ""

### getFaultString

    public String getFaultString()

  get the fault string; this will never be null but may be the empty string

  Returns:
    a fault string

### setFaultReason

    public void setFaultReason(String str)

  This is SOAP 1.2 equivalent of `setFaultString(java.lang.String)`

  Since:
    axis1.1

### getFaultReason

    public String getFaultReason()

  This is SOAP 1.2 equivalent of `getFaultString()`

  Returns:
  Since:
    axis1.1

### setFaultActor

    public void setFaultActor(String actor)

  set the fault actor

  Parameters:
    `actor` - fault actor

### getFaultActor

    public String getFaultActor()

  get the fault actor

  Returns:
    actor or null

### getFaultRole

    public String getFaultRole()

  This is SOAP 1.2 equivalent of `getFaultActor()`

  Returns:
  Since:
    axis1.1

### setFaultRole

    public void setFaultRole(String role)

  This is SOAP 1.2 equivalent of `setFaultActor(java.lang.String)`

  Since:
    axis1.1

### getFaultNode

    public String getFaultNode()

  This is new in SOAP 1.2

  Returns:
  Since:
    axis1.1

### setFaultNode

    public void setFaultNode(String node)

  This is new in SOAP 1.2

  Since:
    axis1.1

### setFaultDetail

    public void setFaultDetail(Element[] details)

  set the fault detail element to the arrary of details

  Parameters:
    `details` - list of detail elements, can be null

### setFaultDetailString

    public void setFaultDetailString(String details)

  set the fault details to a string element.

  Parameters:
    `details` - XML fragment

### addFaultDetailString

    public void addFaultDetailString(String detail)

  add a string tag to the fault details.

  Parameters:
    `detail` - XML fragment

### addFaultDetail

    public void addFaultDetail(Element detail)

  append an element to the fault detail list

  Parameters:
    `detail` - the new element to add
  Since:
    Axis1.1

### addFaultDetail

    public void addFaultDetail(javax.xml.namespace.QName qname,
                               String body)

  create an element of the given qname and add it to the details

  Parameters:
    `qname` - qname of the element
    `body` - string to use as body

### getFaultDetails

    public Element[] getFaultDetails()

  get all the fault details

  Returns:
    an array of fault details, or null for none

### lookupFaultDetail

    public Element lookupFaultDetail(javax.xml.namespace.QName qname)

  Find a fault detail element by its qname

  Parameters:
    `qname` - name of the node to look for
  Returns:
    the matching element or null
  Since:
    axis1.1

### removeFaultDetail

    public boolean removeFaultDetail(javax.xml.namespace.QName qname)

  find and remove a specified fault detail element

  Parameters:
    `qname` - qualified name of detail
  Returns:
    true if it was found and removed
  Since:
    axis1.1

### output

    public void output(SerializationContext context)
                throws Exception

  add this fault and any needed headers to the output context

  Parameters:
    `context` -
  Throws:
    `Exception`

### toString

    public String toString()

  string operator

  Returns:
    the current fault string; may be empty but never null

### printStackTrace

    public void printStackTrace(PrintStream ps)

  The override of the base class method prints out the fault info before the stack trace

  Parameters:
    `ps` - where to print

### printStackTrace

    public void printStackTrace(PrintWriter pw)

  The override of the base class method prints out the fault info before the stack trace

  Parameters:
    `pw` - where to print

### addHeader

    public void addHeader(SOAPHeaderElementAxisImpl header)

  Add a SOAP header which should be serialized along with the fault.

  Parameters:
    `header` - a SOAPHeaderElement containing some fault-relevant stuff

### getHeaders

    public ArrayList getHeaders()

  Get the SOAP headers associated with this fault.

  Returns:
    an ArrayList containing any headers associated with this fault

### clearHeaders

    public void clearHeaders()

  clear all fault headers

### writeDetails

    public void writeDetails(javax.xml.namespace.QName qname,
                             SerializationContext context)
                      throws IOException

  Writes any exception data to the faultDetails This can be overrided (and is) by emitted exception clases. The base implementation will attempt to serialize exception data the fault was created from an Exception and a type mapping is found for it.

  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002 JBoss Group, LLC. All Rights Reserved.